"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringify = exports.scanDirectory = void 0;
// builtin
var path_1 = require("path");
var fs_1 = require("fs");
// external
var ignorefs_1 = require("ignorefs");
/** Get the string or buffer of a file */
function readHelper(path, opts) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    (0, fs_1.readFile)(path, opts, function (err, data) {
                        if (err)
                            reject(err);
                        else
                            resolve(data);
                    });
                })];
        });
    });
}
/** Get the stat */
function statsHelper(path) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    (0, fs_1.stat)(path, function (err, stats) {
                        if (err)
                            reject(err);
                        else
                            resolve(stats);
                    });
                })];
        });
    });
}
/** Get a list of files */
function listHelper(directory) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    (0, fs_1.readdir)(directory, function (err, files) {
                        if (err)
                            reject(err);
                        else
                            resolve(files);
                    });
                })];
        });
    });
}
/** Scan the contents of a directory */
function scanDirectory(opts) {
    return __awaiter(this, void 0, void 0, function () {
        var pendingLists, pendingStats, pendingReads, results, abort, signal, sortedResults_1, err_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    // options
                    opts = Object.assign({}, opts);
                    if (opts.includeRoot == null)
                        opts.includeRoot = false;
                    if (opts.recurse == null)
                        opts.recurse = true;
                    if (opts.fileAction == null)
                        opts.fileAction = opts.action;
                    if (opts.dirAction == null)
                        opts.dirAction = opts.action;
                    _a = {
                        absolutePath: (0, path_1.resolve)(opts.directory),
                        relativePath: '.',
                        basename: (0, path_1.basename)(opts.directory),
                        directory: true
                    };
                    return [4 /*yield*/, statsHelper(opts.directory)];
                case 1:
                    pendingLists = [
                        (_a.stats = _b.sent(),
                            _a.parent = null,
                            _a.children = null,
                            _a.data = null,
                            _a)
                    ];
                    pendingStats = [];
                    pendingReads = [];
                    results = {};
                    if (opts.includeRoot)
                        results['.'] = pendingLists[0];
                    abort = typeof AbortController !== 'undefined' ? new AbortController() : null // v14.7+
                    ;
                    signal = abort === null || abort === void 0 ? void 0 : abort.signal;
                    _b.label = 2;
                case 2:
                    _b.trys.push([2, 6, , 7]);
                    _b.label = 3;
                case 3:
                    if (!(pendingLists.length || pendingStats.length || pendingReads.length)) return [3 /*break*/, 5];
                    return [4 /*yield*/, Promise.all(__spreadArray(__spreadArray(__spreadArray([], __read(pendingLists
                            .splice(0, pendingLists.length)
                            .map(function (result) {
                            return __awaiter(this, void 0, void 0, function () {
                                var files, files_1, files_1_1, basename, child;
                                var e_1, _a;
                                return __generator(this, function (_b) {
                                    switch (_b.label) {
                                        case 0: return [4 /*yield*/, listHelper(result.absolutePath)];
                                        case 1:
                                            files = (_b.sent()).sort();
                                            result.children = {};
                                            try {
                                                for (files_1 = __values(files), files_1_1 = files_1.next(); !files_1_1.done; files_1_1 = files_1.next()) {
                                                    basename = files_1_1.value;
                                                    child = {
                                                        absolutePath: (0, path_1.join)(result.absolutePath, basename),
                                                        relativePath: (0, path_1.join)(result.relativePath, basename),
                                                        basename: basename,
                                                        directory: null,
                                                        stats: null,
                                                        parent: result,
                                                        children: null,
                                                        data: null,
                                                    };
                                                    result.children[child.basename] = child;
                                                    pendingStats.push(child);
                                                }
                                            }
                                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                            finally {
                                                try {
                                                    if (files_1_1 && !files_1_1.done && (_a = files_1.return)) _a.call(files_1);
                                                }
                                                finally { if (e_1) throw e_1.error; }
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        })), false), __read(pendingStats
                            .splice(0, pendingStats.length)
                            .map(function (wipResult) {
                            return __awaiter(this, void 0, void 0, function () {
                                var stats, directory, result, skip, skip;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, statsHelper(wipResult.absolutePath)];
                                        case 1:
                                            stats = _a.sent();
                                            directory = stats.isDirectory();
                                            result = Object.assign(wipResult, {
                                                directory: directory,
                                                stats: stats,
                                                parent: wipResult.parent,
                                                children: null,
                                                data: null,
                                            });
                                            // skip by ignore options?
                                            if ((0, ignorefs_1.isIgnoredPath)(result, opts)) {
                                                if (result.parent)
                                                    delete result.parent.children[result.basename];
                                                return [2 /*return*/];
                                            }
                                            // dir or file
                                            if (result.directory) {
                                                skip = opts.dirAction === false ||
                                                    (opts.dirAction && opts.dirAction(result) === false);
                                                if (skip) {
                                                    if (result.parent)
                                                        delete result.parent.children[result.basename];
                                                    return [2 /*return*/];
                                                }
                                                // save
                                                results[result.relativePath] = result;
                                                if (opts.recurse)
                                                    pendingLists.push(result);
                                            }
                                            else {
                                                skip = opts.fileAction === false ||
                                                    (opts.fileAction && opts.fileAction(result) === false);
                                                if (skip) {
                                                    if (result.parent)
                                                        delete result.parent.children[result.basename];
                                                    return [2 /*return*/];
                                                }
                                                // save
                                                results[result.relativePath] = result;
                                                if (opts.encoding != null)
                                                    pendingReads.push(result);
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        })), false), __read(pendingReads
                            .splice(0, pendingReads.length)
                            .map(function (result) {
                            return __awaiter(this, void 0, void 0, function () {
                                var _a, _b;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            if (!(opts.encoding === 'binary')) return [3 /*break*/, 2];
                                            ;
                                            _a = result;
                                            return [4 /*yield*/, readHelper(result.absolutePath, {
                                                    encoding: 'binary',
                                                    signal: signal,
                                                })];
                                        case 1:
                                            _a.data = _c.sent();
                                            return [3 /*break*/, 4];
                                        case 2:
                                            if (!(opts.encoding != null)) return [3 /*break*/, 4];
                                            ;
                                            _b = result;
                                            return [4 /*yield*/, readHelper(result.absolutePath, {
                                                    encoding: opts.encoding,
                                                    signal: signal,
                                                })];
                                        case 3:
                                            _b.data =
                                                (_c.sent());
                                            _c.label = 4;
                                        case 4: return [2 /*return*/];
                                    }
                                });
                            });
                        })), false))];
                case 4:
                    _b.sent();
                    return [3 /*break*/, 3];
                case 5:
                    sortedResults_1 = {};
                    Object.keys(results)
                        .sort()
                        .forEach(function (key) {
                        sortedResults_1[key] = results[key];
                    });
                    return [2 /*return*/, sortedResults_1];
                case 6:
                    err_1 = _b.sent();
                    abort === null || abort === void 0 ? void 0 : abort.abort();
                    throw err_1;
                case 7: return [2 /*return*/];
            }
        });
    });
}
exports.scanDirectory = scanDirectory;
/** Scan the contents of a directory, with compatibility for scandirectory < v8 */
function scanDirectoryCompatibility() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    return __awaiter(this, void 0, void 0, function () {
        var opts, actionCallback_1, dirActionCallback_1, fileActionCallback_1, results, list, tree, err_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    opts = {};
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    // parse arguments into options
                    args.forEach(function (arg) {
                        switch (typeof arg) {
                            case 'string':
                                opts.directory = arg;
                                break;
                            case 'function':
                                opts.next = arg;
                                break;
                            case 'object':
                                Object.assign(opts, arg);
                                break;
                            default:
                                throw new Error('scandirectory: unknown argument: ' + JSON.stringify(arg));
                        }
                    });
                    // handle deprecations and verifications
                    if (opts.next)
                        opts.includeRoot = true;
                    if (opts.path != null)
                        opts.directory = opts.path;
                    if (opts.readFiles) {
                        throw new Error('scandirectory: readFiles renamed to encoding: if you used readFiles = true, use encoding = "utf8", if you used readFiles = "binary", use encoding = "binary"');
                    }
                    if (!opts.directory) {
                        throw new Error('scandirectory: path is needed');
                    }
                    // action callback compatibility
                    if (opts.action && opts.action.length >= 1) {
                        actionCallback_1 = opts.action;
                        opts.action = function (result) {
                            return actionCallback_1(result.absolutePath, result.relativePath, result.basename, Object.assign({ directory: result.directory }, result.stats));
                        };
                    }
                    if (opts.dirAction && opts.dirAction.length >= 1) {
                        dirActionCallback_1 = opts.dirAction;
                        opts.dirAction = function (result) {
                            return dirActionCallback_1(result.absolutePath, result.relativePath, result.basename, Object.assign({ directory: result.directory }, result.stats));
                        };
                    }
                    if (opts.fileAction && opts.fileAction.length >= 1) {
                        fileActionCallback_1 = opts.fileAction;
                        opts.fileAction = function (result) {
                            return fileActionCallback_1(result.absolutePath, result.relativePath, result.basename, Object.assign({ directory: result.directory }, result.stats));
                        };
                    }
                    return [4 /*yield*/, scanDirectory((0, ignorefs_1.upgradeOptions)(opts))];
                case 2:
                    results = _a.sent();
                    if (opts.next) {
                        if (opts.next.length === 1) {
                            opts.next(null);
                        }
                        else {
                            list = toList(results);
                            if (opts.next.length === 2) {
                                opts.next(null, list);
                            }
                            else if (opts.next.length === 3) {
                                tree = toTree(results);
                                opts.next(null, list, tree);
                            }
                            else
                                throw new Error('scandirectory: next function must accept 1, 2, or 3 arguments');
                        }
                    }
                    return [2 /*return*/, results];
                case 3:
                    err_2 = _a.sent();
                    if (opts.next) {
                        opts.next(err_2);
                        return [2 /*return*/, {}];
                    }
                    else {
                        throw err_2;
                    }
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.default = scanDirectoryCompatibility;
/** Compatibility helper for {@link scanDirectoryCompatibility} to generate results compatible with {@link CompatibilityNextCallback} */
function toList(results) {
    var e_2, _a;
    var _b;
    var list = {};
    try {
        // Object.entries requires Node.js >= 8
        for (var _c = __values(Object.keys(results)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var key = _d.value;
            var value = results[key];
            list[key] = (value.directory ? 'dir' : (_b = value.data) !== null && _b !== void 0 ? _b : 'file');
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_2) throw e_2.error; }
    }
    delete list['.'];
    return list;
}
/** Compatibility helper for {@link scanDirectoryCompatibility} to generate results compatible with {@link CompatibilityNextCallback} */
function toTree(results, descending) {
    var e_3, _a;
    var _b;
    if (descending === void 0) { descending = false; }
    if (!results)
        return {};
    var tree = {};
    if (!descending) {
        return toTree(results['.'].children, true);
    }
    try {
        // Object.entries requires Node.js >= 8
        for (var _c = __values(Object.keys(results)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var key = _d.value;
            var value = results[key];
            tree[key] = (value.directory ? toTree(value.children, descending) : (_b = value.data) !== null && _b !== void 0 ? _b : true);
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
        }
        finally { if (e_3) throw e_3.error; }
    }
    return tree;
}
/** Convert {@link Results} into a non-recursive JSON string */
function stringify(any, indentation) {
    return JSON.stringify(any, function (key, value) {
        if (key === 'parent')
            return value.relativePath;
        return value;
    }, indentation);
}
exports.stringify = stringify;
